#!/usr/bin/env python
# Copyright 2004 Paul Sladen <thinkpad@paul.sladen.org>, GPL

from OpenGL.GL import *

def axis():
    glBegin(GL_LINES)
    if 1:
        # X
        glColor3f(1, 0.5, 0.5)
	glVertex3f(0, 0, 0)
	glVertex3f(1, 0, 0)
        
	glVertex3f(1.1,-0.15, 0)
	glVertex3f(1.3, 0.15, 0)
	glVertex3f(1.3,-0.15, 0)
	glVertex3f(1.1, 0.15, 0)

        # Y
        glColor3f(1, 1, 0)
	glVertex3f(0, 0, 0)
	glVertex3f(0, 1, 0)

	glVertex3f( 0, 1.1, 0)
	glVertex3f( 0, 1.25, 0)
	glVertex3f( 0, 1.25, 0)
	glVertex3f(-0.1, 1.4, 0)
	glVertex3f( 0, 1.25, 0)
	glVertex3f( 0.1, 1.4, 0)

        # Z
        glColor3f(0.5, 0.5, 1)
	glVertex3f(0, 0, 0)
	glVertex3f(0, 0, 1)

    	glVertex3f( 0.1, 0, 1.1)
    	glVertex3f( -0.1, 0, 1.1)
    	glVertex3f( -0.1, 0, 1.1)
    	glVertex3f( 0.1, 0, 1.4)
    	glVertex3f( 0.1, 0, 1.4)
    	glVertex3f( -0.1, 0, 1.4)
    glEnd()

def grid(n = 5, step = 1):
    if n < n:
        n = step
    glBegin(GL_LINES)
    if 1:
        for i in range(step-n, n, step):
            glVertex3f(i, -n, 0)
            glVertex3f(i,  n, 0)
            glVertex3f(-n, i, 0)
            glVertex3f( n, i, 0)
    glEnd()

def redraw(o):
    glClearColor(0.33, 0.33, 0.5, 0)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glOrtho(0, 1, 0, 1, 0, 1)
    glScale(1, 1, -1)
    glRotate(-90, 1, 0, 0)

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_LINE_SMOOTH);

    glDisable(GL_LIGHTING)
    glColor3f(0.9, 1, 0.9)
    glLineWidth(0.5)
    grid(3)
    glTranslate(0.01, 0.01, 0.01)
    glLineWidth(2)
    axis()
    glTranslate(-0.01, -0.01, -0.01)
    glBegin(GL_LINES)
    if 1:
        pass
    glEnd()
    glEnable(GL_LIGHTING)

if __name__ == '__main__':
    from OpenGL.GLU import *
    from OpenGL.GLUT import *
    import OpenGL.Tk

    w = OpenGL.Tk.Opengl(width = 400, height = 400, double = 1)
    w.redraw = redraw
    w.pack(side = 'top', expand = 1, fill = 'both')
    w.mainloop()








