#!/usr/bin/env python

import string, sys
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
import select

from glgridaxis import grid, axis
from glthinkpad import draw_thinkpad

n = 0
m = 0

pitch, roll = 0, 0
lid, nipple, keyboard = 1, 1, 1

def display(*args):
    glClearColor(0.0, 0.0, 0.0, 0.0)
    glClear(GL_COLOR_BUFFER_BIT)
    glColor3f(1.0,1.0,0.0)

    glBegin(GL_LINES)
    if 1:
        glVertex(-1, -1, 0)
        glVertex( -1, 1, 0)
        glVertex( 1,  1, 0)
        glVertex( 1, -1, 0)
    glEnd()
    glBegin(GL_POINTS)
    if 1:
        glVertex(0, 0, 0)
    glEnd()
    
    glFlush()
    glutSwapBuffers()

def resize(w, h):
    glViewport(0, 0, w, h)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(50, float(w)/float(h), 1, 100)

def check_for_update():
    #print "check_for_update() called"
    global pitch, roll, lid, keyboard, nipple
    if len(select.select([sys.stdin.fileno()], [], [], 0.01)[0]):
        try:
	    s = sys.stdin.readline().strip()
	    d = s.split(' ')
	    print `d`, len(d)
	    pitch, roll = map(float, d[0:2])
	    lid, nipple, keyboard = map(int, d[2:5])
	    pitch = -pitch
	except: pass

def redraw():
    global n, m

    check_for_update()

    if n < 70:
        n += 1
    m += 1
	    
    #print "redraw() called!"
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    glClearColor(0.33, 0.33, 0.5, 0)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glOrtho(-0.5, 0.5, -0.5, 0.5, -0.5, 0.5)
    glScale(1, 1, -1)
    glRotate(-90, 1, 0, 0)

    glTranslate(0, 3 + n * 0.03, n * -0.005)
    glRotate(20, 1, 0, 0)

    glRotate(m * 0.3, 0, 0, 1)

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_LINE_SMOOTH);

    glDisable(GL_LIGHTING)
    glColor3f(0.9, 1, 0.9)
    glLineWidth(0.5)
    #grid()
    glTranslate(0.01, 0.01, 0.01)
    glLineWidth(2)
    #axis()
    glTranslate(-0.01, -0.01, -0.01)
    glBegin(GL_LINES)
    if 1:
        pass
    glEnd()
    glEnable(GL_LIGHTING)

    glRotate(roll, 0, 1, 0)
    glRotate(pitch, 1, 0, 0)
    draw_thinkpad(n * lid * 1.5, keyboard, nipple)

    glFlush()
    glutSwapBuffers()

def main():
    glutInit('None')
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitWindowSize(400, 300)
    glutCreateWindow('Accelerometer Viewer')

    glutSetReshapeFuncCallback(resize)
    glutSetDisplayFuncCallback(redraw)
    glutSetIdleFuncCallback(redraw)
    glutReshapeFunc()
    glutDisplayFunc()
    glutIdleFunc()

    glutMainLoop()

if __name__ == '__main__':
    main()



